rem
	bbdoc: Thanks to http://www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html
end rem
Function pointInPolygon:Int(a:Float[], x:Int, y:Int)
	
	Local n:Int = a.Length
	Local j:Int = n - 2, c:Int
	
	For Local i:Int = 0 Until n Step 2
		If ((a[i + 1] > y) <> (a[j + 1] > y)) And (x < (a[j] - a[i]) * (y - a[i + 1]) / (a[j + 1] - a[i + 1]) + a[i]) Then
			c = Not c
		EndIf
		j = i
	Next
	
	Return c
	
End Function


Function pass_time:Int(hours:Int)
	
	For Local t:Int = 0 Until hours
		
		If(Not sleeping) Then
			stat_fatigue:+5
			If(stat_fatigue > 90) Then
				fall_asleep()
				Return t
			EndIf
		
		EndIf
		
		' Door bell
		If(Rand(0, 15) = 0) Then
			TAlert.show("Door bell is ringing")
			
			doortime = stat_time_left
			doortype = Rand(0, 2)
			If(item_sofa.active) doortype = 1
			doorvisitor = True
			
			Return t
		EndIf

		' Windows update
		If(item_table.active And Rand(0, 17) = 0) Then
			If(updates_from_windows = 0) Then
				TAlert.show("Windows needs to install updates (1 hour)")
				
				Return t + pass_time(1)
			ElseIf(updates_from_windows = 1) Then
				TAlert.show("Windows needs to install MORE updates (1 hour)")
				
				Return t + pass_time(1)
			EndIf
			updates_from_windows:+1
		EndIf
		
		If(stat_time_left = 5 And Not did_warn_about_short_time) Then
			TAlert.show("Only " + stat_time_left + " hours until deadline! omg panic")
			did_warn_about_short_time = True
			Return t
		EndIf
		
		' Decrease time
		stat_time_left:-1
		
		If(stat_time_left <= 0 And stat_progress < 100) Then
			set_panel_text(text_loose_time)
			game_lost = True
			TAlert.show("Game over")
		EndIf
		
		mom_hours:-1
		If(mom_hours <= 0) Then
			item_sofa.active = False
			item_sofa.clicklabel = "Nobody there"
		EndIf
		
		
		If(stat_time_left Mod 5 = 0) Then
			item_plant.active = False
		EndIf
		
		stat_caffeine:-5
		stat_self_esteem:-10
		stat_starvation:+3
		
		If(stat_caffeine < 0) Then
			stat_caffeine = 0
		EndIf
		If(stat_self_esteem < 0) Then
			stat_self_esteem = 0
		EndIf
		If(stat_starvation > 100) Then
			stat_starvation = 100
		EndIf
		
	Next
	
	Return hours
	
End Function

Function make_progress(hours:Int)
		
	Local t:Int = pass_time(hours)
	TMessage.add_message("Worked for " + t + " hours.")
	If(t > 0) Then
		Local base:Int = (800 * t)
		base:-stat_fatigue * 2 * t
		base:-stat_starvation * 2 * t
		If(stat_caffeine >= 70) base:/2
		base:/100
		stat_progress:+base
		stat_score:+stat_progress * stat_self_esteem
	EndIf
	
	If(stat_fatigue >= 80) Then
		set_panel_text(text_warning_sleepy)
	EndIf
	If(stat_starvation >= 80) Then
		set_panel_text(text_warning_hungry)
	EndIf
	
	If(stat_progress >= 100 And stat_time_left >= 0) Then
		stat_progress = 100
		set_panel_text(text_win)
		wingame()
	EndIf
	
End Function

Function fall_asleep()
	
	If(Not item_bed.active) Then
		TAlert.show("Yeah. Fell asleep doing that.")
	EndIf

	set_panel_text(text_sleeping)
	sleep_duration = 0
	sleeping = True

End Function

Function zzz()	

	If(stat_fatigue > 80) Then
		'TMessage.add_message("zZZz huh? no you can't have my pony *mumble* ZZZzzz")
		sleep_duration:+pass_time(8)
		
	Else If(stat_fatigue > 60)
		'TMessage.add_message("YAAAAAAAAAAAAAAAAWN zzZZZzzZZZ")
		sleep_duration:+pass_time(5)
		
	Else If(stat_fatigue > 40)
		'TMessage.add_message("I don't wanna wake up X( I don't have to get up zzZZzzzz")
		sleep_duration:+pass_time(3)
		
	Else If(stat_fatigue > 20)
		'TMessage.add_message("So. Tired. Need Sleep.... ugh")
		sleep_duration:+pass_time(2)
		
	Else If(stat_fatigue > 0)
		'TMessage.add_message("Alright alright your slave is at service meanie :S")
		sleep_duration:+pass_time(2)
		
	Else
		'TMessage.add_message("Rise and shine")
		sleep_duration:+pass_time(1)
	EndIf
	
	If(stat_fatigue <= 20) Then
		TMessage.add_message("I have slept For " + sleep_duration + " hours. WOah")
		set_panel_text(text_welcome)
		sleep_duration = 0
		sleeping = False
	Else
		 'Give penalty for sleeping out of the bed
		If(item_bed.active) Then
			stat_fatigue:-8 * sleep_duration
		Else
			stat_fatigue:-6 * sleep_duration
		EndIf
		
		If(stat_fatigue < 0) Then
			stat_fatigue = 0
		EndIf
	EndIf
	
End Function


Function set_panel_text(i:Int)
	Local text:String[][] = [ ..
		["MY APARTMENT", "This is my home. I'm the", "blue haired guy. I must make ", "a game in 48 hours.", "Failure is not an option.", "", "(Use the mouse)"],  ..
		["I FELL ASLEEP...", "Try clicking to awake me.", "As much as is needed..."],  ..
		["FATIGUE", "WOW I'm tired.", "Can't focus anymore"],  ..
		["HUNGRY", "Could go for somethind edible", "My stomach is distracting"],  ..
		["SAD", "I are teh sad", "Lost my motivation"],  ..
		["WE BEAT THE GAME :3", "Yay.", "Have some score and stuff."],  ..
		["DEADLINE REACHED", "Game over"] ..
	]
	
	text_in_panel = text_in_panel[..text[i].length]
	For Local s:Int = 0 Until text[i].length
			text_in_panel[s] = text[i][s]
	Next
End Function


Function wingame()
	
	game_won = True

	stat_score:+stat_score * stat_time_left / 48
	stat_score:+stat_economy
	
	'Update hiscore?
	If(stat_score > stat_hiscore) Then
		Local file:TStream = WriteFile("highscore.txt")
		If file Then
			WriteLine(file, stat_score)
			CloseStream file
		EndIf
		stat_hiscore = stat_score
	EndIf
	
	
	
	TAlert.show("SCORE: " + stat_score)
	
	
End Function